﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace PowerPlanner
{

    public partial class ClsPart : UserControl
    {
        public enum PartType
        {
            Box,
        }
        private Image mypicture = null;
        private PartType part = PartType.Box;
        public Label partlabel = new Label();
        private GraphicsPath path = null;

        int marginhorz = 5, marginvert = 5;
        public ClsPart()
        {
        }

        public PartType Type_
        {
            get
            {
                return part;
            }
            set
            {
                part = value;
                mypicture = RefreshPath();
                this.Invalidate();
            }
        }

        // Create the corresponding GraphicsPath for the part, and apply
        // it to the control by setting the Region property.
        private Image RefreshPath()
        {
            Image canvas = new Bitmap(1000, 1000);

            path = new GraphicsPath();
            partlabel.Font = new Font("Arial", 8, partlabel.Font.Style, partlabel.Font.Unit);

            path.AddRectangle(this.ClientRectangle);
            partlabel.Location = new Point(marginhorz - 2, marginvert);
            partlabel.Width = Convert.ToInt16(this.ClientRectangle.Width) - marginhorz * 2;
            partlabel.Height = Convert.ToInt16(15);
            partlabel.Name = ("Boxlabel");
            this.Controls.Add(partlabel);
            Graphics g = Graphics.FromImage(canvas);
            Graphics.FromImage(canvas).Clear(this.BackColor);
            g.SmoothingMode = SmoothingMode.AntiAlias;
            g.FillPath(new SolidBrush(this.BackColor), path);
            g.DrawPath(new Pen(this.ForeColor, 3), path);
            g.Dispose();
            this.Region = new Region(path);
            return canvas;
        }

        protected override void OnResize(System.EventArgs e)
        {
            base.OnResize(e);
            mypicture = RefreshPath();
            Invalidate();
        }

        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            base.OnPaint(e);
            if (path != null)
            {
                //e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
                //e.Graphics.FillPath(new SolidBrush(this.BackColor), path);
                //e.Graphics.DrawPath(new Pen(this.ForeColor, 4), path);
                e.Graphics.DrawImage(mypicture, 0, 0); //draw the image
                //mypicture.Save(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\LTP\" + Type_ + indexnumber + ".jpg", ImageFormat.Jpeg);
            }
        }
    }
}
